/*
 * File:   appcommon.h
 * Author: alvaro
 *
 * Created on 9 de abril de 2012, 2:01
 */

#include "variables.h"
#include <stdio.h>

// Definicion de un tipo base para que funcione tanto en arquitecturas
// de 32 bits, como de 64 bits
#ifdef __LP64__
 typedef unsigned long long int baseType;
#else
 typedef unsigned long int baseType;
#endif

// upperlimit used in the following invocation
int upper_limit;

// partial loop bounds
int lower_bound, upper_bound;

/** @param endLoop flag to indicate when a loop must be stalled
**  0 keep going
**  1 stopping loop
**/
int endLoop;
/** @param endReturn flag to indicate when a function must be stalled
**  0 do not return
**  1 invoke return
**/
int endReturn;


// Definicion de la nueva estructura.
#define T_POINTER 0
#define T_SIZE 1
#define T_DATA 2
#define T_STATE 3
typedef struct threadCopy_structure{
    baseType matriz[4][MAX_POINTER];
}threadCopy_structure;

// Definicion de la ventana deslizante
int wheel[wsize];
// Definicion de los datos de un slot de la ventana
typedef struct wheel_structure{
    threadCopy_structure *pointer;
    unsigned int lastData;
    unsigned int maxData;
}wheel_structure;
wheel_structure wheel_data[wsize];

int wheel_ns;
int wheel_ms;

// Vector with variable block size
int varblock[3][max_upper_limit+8];
int maxblock;

// thread id's
int tid;

// Array for storing MODULO indexes.
// This array will be filled whit data in specinit()
int modvector[max_upper_limit + 8];

// Declaracion de funciones

int specstart(int iterations);
int specload_pointer(unsigned char* address, unsigned int byteSize,
        unsigned int current, unsigned char* value);
int specstore_pointer(unsigned char* address, unsigned int byteSize,
        unsigned int current, unsigned char* value);
char threadend_pointer(int *current, int *nonSpeculative);
void dynscheduler(int chunk);
int commit();

void specinit();
int getFirstBlock(int *current, int *nonSpeculative);
void clean(int freedcell);

void freeWheel(int current);
void breakEnd(int current);
void returnEnd(int current);
void squashThreads(int current);

void initializeCounters();
void specepilogue();
