/**
 * @author Alvaro Garcia Yaguez
 * @date 25th of January 2011
 * Specific variables from speculative engine
**/

#include "variables.h"

/** @param currentBlock block that it is 
    currently being executed by each thread **/
//static int currentBlock[threads];
int current;

/** @param nonSpeculative will be 1 if you are the thread
**  non speculative before starting a block of iterations. Otherwise
**  the value will be 0 **/
//static int nonSpeculative[threads];
int nonSpeculative;
char retflag;

/** @param countException
    count the total number of times an exception is produced
    an excepction can be SIGFPE, SIGSEGV, exit, continue, break, return
**/
static long int countExceptions=0;

/** @param countException
    count the total number of blocks restarted due to exceptions
    an excepction can be SIGFPE, SIGSEGV, exit, continue, break, return
**/
static long int exceptionsBlocksRestart=0;

/** @param countException
    count the total number a violation is produced
**/
static int spec_violations;

/** @param countException
    count the total number a squash is produced
**/
static int spec_squashes;

/** @param SC_threadend1
    number of access to first Critical Section in threadend function
**/
int SC_threadend1;

/** @param SC_threadend2
    number of access to second Critical Section in threadend function
**/
int SC_threadend2;

/** @param SC_specstore
    number of access to Critical Section in specstore function
**/
int SC_specstore;

/** @param SC_commit
    number of access to commit function
**/
int SC_commit;

