
#include <stdio.h>
#include <stdlib.h>
#include "miejemplovariables.h"

//***********************************************************************
// speccode: OpenMP header file included
#include <omp.h>
//***********************************************************************
//***********************************************************************
// speccode: Main header file with all common variables
#include "specEngine.h"
//***********************************************************************

int main() {

    // Variables locales
    // P indica la iteraccion en la que estamos, Q indica el indice del vector
    int P, Q, aux, i;
    FILE *fichero;
    int sumatorio1 = 0;
    int sumatorio2 = 0;
    int vector2[MAX];
    int aux_fscanf;

    //dsadasdas
    specinit();

    // Apertura y lectura del fichero

    if ((fichero = fopen("rand1000000.in", "r")) == NULL) {
        printf("Error en apertura del fichero para lectura \n ");
        exit(0);
    } else {
        aux_fscanf = fscanf(fichero, "%d", &aux);
        for (i = 0; i < MAX; i++) {
            vector[i] = aux;
            vector2[i] = aux;
            aux_fscanf = fscanf(fichero, "%d", &aux);
        }
        fclose(fichero);
    }

    // miejemplocode: debug
    //  for ( i = 0; i < MAX; i++)
    //    printf("%d\n", vector[i]);
    // miejemplocode: end debug

    // El bucle no es paralelizable porque los indices
    // de los elementos del vector donde escribimos
    // dependen de los valores de la entrada del fichoer
    // ESTO ES LO QUE SE BUSCA
    // EMPEZAMOS

    //***********************************************************************
    // speccode: OMP threading directive
    omp_set_num_threads(threads);
    // speccode: initialize speculation structures
    specstart(NITER);
    // speccode: variable upper limit inicialization
    //upper_limit = NITER;
    //***********************************************************************
    //***********************************************************************
    // speccode: Start profiling
    // collector_resume();
    //***********************************************************************
    // speccode: Speculative loop
    int iteration, ini, nIterations;
    int value = 0;
    int linear = 0;


#pragma omp parallel default(none)                                  \
               private(Q,P,aux,linear, iteration, ini,nIterations, value, \
                       current, tid, retflag, stdout, nonSpeculative)    \
              shared(vector, wheel_ns, wheel_ms,    \
                     wheel, upper_limit, varblock, endLoop, endReturn)
    {

#pragma omp for \
   schedule(static)
        //for ( P = 1 ; P <= NITER ; P++ )
        //initLoopSpecEngine(vector,P,0,1)
        /**
         * @author Alvaro Estebanez Lopez
         * @arg iteration index of the iteration is being excuted inside the speculative loop
         * @arg ini initial index of the loop
         * @arg IDLOOP loop identifier
         * Assigning the first block each thread
         * According to flag exceptions checkPoint is enabled or disabled
         **/
        //IDLOOP = 1;
        //#define initLoopSpecEngine(iteration,ini,IDLOOP)

        //iteration = P;
        for (tid = 0; tid <= threads - 1; tid++) {

            ini = 0;
            if (getFirstBlock(&current, &nonSpeculative) == 0) {
                /*printf("NO TIENES TRABAJO %d \n",omp_get_thread_num());*/
                goto labelEndLoop;
            }
            iteration = varblock[0][current] + ini;
            varblock[2][current] = varblock[2][current] + 1;
            //printf("\t\tvarblock[0][current]:%d,current:%d,iteration:%d\n",varblock[0][current],current,iteration);
labelStartIteration: //printf("ENDLOOP,iteration:%d,current:%d\n",iteration,current);
            //  Codigo del bucle

            Q = iteration % (MAX) + 1;

            //***********************************************************************
            // speccode: speculative load. Original line:
            //    aux = vector[Q-1];
            //linear = (Q - 1);
            //if (specload(linear, current, &value, (int *) vector, &my_IV_tail) == -1)
            //    earlySquash(1);
            specload_pointer((unsigned char *) &(vector[Q-1]), sizeof (vector[Q-1]), current, (unsigned char *) &value);
            aux = value;
            //***********************************************************************

            Q = (4 * aux) % (MAX) + 1;

            //***********************************************************************
            // speccode: speculative store. Original line:
            //     vector[Q-1] = aux;
            //linear = (Q - 1);
            value = aux;
            //specstore(linear, current, value, &my_IV_tail);
            specstore_pointer((unsigned char *) &(vector[Q-1]), sizeof (vector[Q-1]), current, (unsigned char *) &value);
            //***********************************************************************

            //endLoopSpecEngine(vector,P,NITER,0,1);
            //endLoopSpecEngine(i, cur_upper_limit, 0, 1);
            //iteration = P;
            nIterations = NITER;
            ini = 0;
            /**
             * @author Alvaro Estebanez Lopez
             * @arg iteration index of the iteration is being excuted inside the speculative loop
             * @arg nIterations total number of iterations in the loop
             * @arg ini initial index of the loop
             * @arg IDLOOP loop identifier
             * Returning point after ending an iteration
             * A new block of iterations will be assigned providing that
             * there are still work to execute
             **/
            //#define endLoopSpecEngine(iteration, nIterations, ini, IDLOOP)
            /**********************************************************************		\
            // speccode: end of thread and commit						\
            //           First check if block of iterations is done **************/		\
	if (endLoop || endReturn) {
                freeWheel(current);
                goto labelEndLoop;
            }
labelEndIteration:
            if ((iteration != varblock[1][current] + ini) && (iteration < nIterations - 1)) {
                iteration = iteration + 1;
                goto labelStartIteration;
            }
            /* Thread done, perform the commit */
labelSquash:
            retflag = threadend_pointer(&current, &nonSpeculative);
            /* End if job done */
            if (retflag == JOBDONE) goto labelEndLoop;
            if (retflag == JOBTODO) {
                /*  Set loop variable */
                iteration = varblock[0][current] + ini;
                varblock[2][current] = varblock[2][current] + 1;
                goto labelStartIteration;
            }
labelEndLoop:
            ; /*freeWheel(current);*/
        } /*End for initLoop()*/

    } // #pragma omp parallel

    for (P = 0; P <= NITER; P++) {


        Q = P % (MAX) + 1;
        aux = vector2[Q - 1];

        Q = (4 * aux) % (MAX) + 1;
        vector2[Q - 1] = aux;
    }

    // Escritura del resultado del vector
    sumatorio1=0;
    printf(" Resultado del vector1\n");
    for (i = 0; i < MAX; i++)
        sumatorio1 = sumatorio1 + vector[i];
    printf("suma vector1=%d\n", sumatorio1);

    sumatorio2=0;
    printf(" Resultado del vector2\n");
    for (i = 0; i < MAX; i++)
        sumatorio2 = sumatorio2 + vector2[i];
    printf("suma vector2=%d\n", sumatorio2);

    if (sumatorio1 != sumatorio2) {
        for (i = 0; i < MAX; i++) {
            if (vector[i] != vector2[i])
                printf("vector[%d]=%d, vector2[%d]=%d,\n", i, vector[i], i, vector2[i]);
        }
    }
    return 0;
}

